#!/bin/sh

dsl_module="dsl_vr9"
dsl_device="dsl_vr9"
mei_device="mei_vr9"
mei_module="mei_vr9"
ptm_module="ifxmips_ptm"
dsl_control_app="dsl_control"
dsl_monitor_app="dsl_monitor"
led_module="led_module"
oamd_app="oamd"

# /bin/mount -t squashfs /filesystem_core.squashfs /core -o loop
# /sbin/pivot_root /core/ /core/wrapper/
# /etc/init.d/debug_ppa_init.sh

#mount -t proc proc proc
#mount -t tmpfs tmpfs /var
#tar cf /var/devices.tar /dev
#mount -t tmpfs tmpfs /dev
#tar xf /var/devices.tar
#mount -t devpts devpts /dev/pts
#mount -t sysfs sysfs /sys

create_gdb_symbol_table() {
    MODULE_BASE=`cat /proc/modules | grep ^$1`
    _MODULE_BASE=${MODULE_BASE##*Live }
    pos=0
    for i in $_MODULE_BASE ; do
        if [ $pos -eq 0 ]; then
            MODULE_BASE=$i
        fi
        if [ $pos -eq 1 ]; then
            MODULE_DATA=$i
        fi
        pos=$((pos + 1))
    done
    # echo add-symbol-file $2 $MODULE_BASE -s .data $MODULE_DATA >> /var/add_sym.txt
    echo add-symbol-file $2 $MODULE_BASE >> /var/add_sym.txt
}


create_test_file() {
	my_wan_ip=`showdsldstat | grep '0: ip' | cut -d' ' -f3`
	pppoe_id=`cat /proc/ppa/api/avm_get_pppoeid`
    maca='00:04:0E:C4:98:49'
    macb='00:04:0E:C4:98:4A'
    macdsl='00:04:0E:C4:98:4C'
    mac_ubuntu_eth2='00:0e:0c:b5:51:ad'
    mac_vbox_eth0='08:00:27:42:80:35'
    mac_vbox_kabel_eth0='08:00:27:4a:7e:95'

###########################################################################################
#  --------------------------   PTM  ------------------------------------------------------
###########################################################################################
	cat > /tmp/testsession << EOF
session 1 = (
ip_proto => 6
ip_tos => 16
src_ip => 192.168.178.253
src_port => ${port}
dst_ip => 212.42.239.119
dst_port => 22
src_mac => ${mac_vbox_eth0}
dst_mac => 00:0c:42:20:54:51
new_src_mac => bc:05:43:ae:37:bc
nat_ip => ${my_wan_ip}
nat_port => 0
new_dscp => 0
pppoe_session_id => ${pppoe_id}
tx_if_name => xxx
new_vci => 0
out_vlan_tag => 0
mtu => 1492
dslwan_qid => 1 
dest_ifid => 7
skb_priority => 6
flags => SESSION_IS_TCP | SESSION_LAN_ENTRY | SESSION_VALID_DSLWAN_QID | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP | SESSION_VALID_PPPOE
);

session 2 = (
ip_proto => 6
ip_tos => 16
nat_ip => 192.168.178.253
dst_port => ${port}
src_ip => 212.42.239.119
src_port => 22
src_mac => 40:00:3d:06:85:e2
dst_mac => ${mac_vbox_eth0}
new_src_mac => ${maca}
dst_ip => ${my_wan_ip}
nat_port => 0
new_dscp => 0
pppoe_session_id => ${pppoe_id}
tx_if_name => xxx
new_vci => 0
out_vlan_tag => 0
mtu => 1500 
dslwan_qid => 3
dest_ifid => 0
skb_priority => 6
flags => SESSION_IS_TCP | SESSION_WAN_ENTRY | SESSION_VALID_DSLWAN_QID | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP | SESSION_VALID_PPPOE
);
EOF

###########################################################################################
#  --------------------------   ATA  ------------------------------------------------------
###########################################################################################
# VBOX: 
#  - angeschlossen an ubuntu-eth1
#  - mac: ${mac_vbox_eth0}
#  - ip: 192.168.178.253
#
# BOX:
#  - eth0 - MII 4 - 192.168.178.1 - ${maca}  
#  - eth1 - MII 2 - 192.168.2.1   - ${macb}  
# 
# Ubuntu: 
#  - eth2 -       - 192.168.2.252 - ${mac_ubuntu_eth2} 


	cat > /tmp/atatestsession << EOF
session 1 = (
ip_proto => 6
ip_tos => 16
src_ip => 192.168.178.253
src_port => 3333
dst_ip => 192.168.2.252
dst_port => 2222
src_mac => ${mac_vbox_eth0}
dst_mac => ${mac_ubuntu_eth2}
new_src_mac => ${macb}
nat_ip => 192.168.2.1
nat_port => 0
new_dscp => 0
mtu => 1500
dest_ifid => 1 
skb_priority => 6
flags => SESSION_IS_TCP | SESSION_LAN_ENTRY | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP 
);

session 2 = (
ip_proto => 6
ip_tos => 16
nat_ip => 192.168.178.253
dst_port => 3333
src_ip => 192.168.2.252
src_port => 2222
src_mac => ${mac_ubuntu_eth2}
dst_mac => ${mac_vbox_eth0}
new_src_mac => ${maca}
dst_ip => 192.168.2.1
nat_port => 0
mtu => 1500 
dest_ifid => 0
skb_priority => 6
flags => SESSION_IS_TCP | SESSION_WAN_ENTRY | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP 
);

EOF

#session 3 = (
#ip_proto => 6
#ip_tos => 16
#src_ip => 192.168.178.20
#src_port => 5006
#dst_ip => 192.168.2.252
#dst_port => 5001
#src_mac => 00:1b:21:41:3e:05
#dst_mac => ${mac_ubuntu_eth2}
#new_src_mac => ${macb}
#nat_ip => 192.168.2.1
#nat_port => 0
#new_dscp => 0
#mtu => 1500
#dest_ifid => 1 
#skb_priority => 6
#flags => SESSION_IS_TCP | SESSION_LAN_ENTRY | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP 
#);
#
#session 4 = (
#ip_proto => 6
#ip_tos => 16
#nat_ip => 192.168.178.20
#dst_port => 5006
#src_ip => 192.168.2.252
#src_port => 5001
#src_mac => ${mac_ubuntu_eth2}
#dst_mac => 00:1b:21:41:3e:05
#new_src_mac => ${maca}
#dst_ip => 192.168.2.1
#nat_port => 0
#mtu => 1500 
#dest_ifid => 0
#skb_priority => 6
#flags => SESSION_IS_TCP | SESSION_WAN_ENTRY | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP 
#);
#
cat > /tmp/ata2testsession << EOF
session 1 = (
ip_proto => 6
ip_tos => 16
src_ip => 192.168.178.253
src_port => 3333
dst_ip => 192.168.188.20
dst_port => 2222
src_mac => ${mac_vbox_eth0}
dst_mac => ${mac_vbox_kabel_eth0}
new_src_mac => ${macb}
nat_ip => 192.168.188.21
nat_port => 0
new_dscp => 0
mtu => 1500
dest_ifid => 1 
skb_priority => 6
flags => SESSION_IS_TCP | SESSION_LAN_ENTRY | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP 
);

session 2 = (
ip_proto => 6
ip_tos => 16
nat_ip => 192.168.178.253
dst_port => 3333
src_ip => 192.168.188.20
src_port => 2222
src_mac => ${mac_vbox_kabel_eth0}
dst_mac => ${mac_vbox_eth0}
new_src_mac => ${maca}
dst_ip => 192.168.188.21
nat_port => 0
mtu => 1500 
dest_ifid => 0
skb_priority => 6
flags => SESSION_IS_TCP | SESSION_WAN_ENTRY | SESSION_VALID_NEW_SRC_MAC | SESSION_VALID_NAT_IP 
);

EOF


	echo "testsession erstellt"
}

case $1 in
	ata)
        export datapath_param="ethwan=2"

        /bin/sh /etc/init.d/E15-device
        major_switch=`cat /proc/devices | grep "switch_api" | tr -d "switch_api"`
        mkdir /dev/switch
        mkdir /dev/switch_api
        mknod /dev/switch/0 c ${major_switch} 0
        mknod /dev/switch_api/0 c ${major_switch} 0
	    switch_utility Enable 

        # echo 3000 >/proc/sys/vm/min_free_kbytes  # -- OOM issue
        # echo 10 >/proc/sys/net/core/netdev_budget # -- bad voice quality

        
        echo "Enter PPA mode"
        
        if [ -z "$datapath_param" ] ; then
        	modprobe ifxmips_ppa_datapath_vr9_e5
        else
            echo "modprobe ifxmips_ppa_datapath_vr9_e5 $datapath_param"
        	modprobe ifxmips_ppa_datapath_vr9_e5 $datapath_param
        fi 
        insmod `find /lib -name ifxmips_ppa_hal_vr9_e5.ko`
        insmod `find /lib -name ifx_ppa_api.ko`
        insmod `find /lib -name  ifx_ppa_api_proc.ko`
        major_ppa=`cat /proc/devices | grep "ifx_ppa" | tr -d "ifx_ppa"`
        mknod /dev/ifx_ppa c ${major_ppa} 0

        brctl delbr lan
        /sbin/ifconfig eth1 192.168.2.1 up
        /sbin/ifconfig eth0 192.168.178.1 up
        /sbin/ifconfig lo 127.0.0.1 up

         echo 1 > /proc/sys/net/ipv4/ip_forward
        if [ -f  /proc/sys/net/netfilter/nf_conntrack_tcp_be_liberal ] ; then
             echo 1 > /proc/sys/net/netfilter/nf_conntrack_tcp_be_liberal
        fi

        sleep 3
        if [ "$hook" = "dummy" ] ; then
        	echo setup dummy hooks
	        ppacmd init -d enable
        else 
        	echo setup normal hooks
	        ppacmd init 
        fi
        sleep 2 

        # echo enable > /proc/ppa/api/hook         
        # sleep 1
        ppacmd control --enable-lan --enable-wan
        sleep 2

        ifconfig -a
        
        sleep 2

        echo addlan
        ppacmd addlan -i eth0
        echo addwan
        ppacmd addwan -i eth1
        
        sleep 3
        echo disable dbg > /proc/ppa/api/dbg 
        echo enable uc >  /proc/ppa/api/dbg
        echo enable hw >  /proc/ppa/api/dbg
	    switch_utility RegisterSet 0xCCD 0x10

	;;
	ppa_eth0)
        /bin/sh /etc/init.d/E15-device
        major_switch=`cat /proc/devices | grep "switch_api" | tr -d "switch_api"`
        mkdir /dev/switch
        mkdir /dev/switch_api
        mknod /dev/switch/0 c ${major_switch} 0
        mknod /dev/switch_api/0 c ${major_switch} 0
	    switch_utility Enable 

        # echo 3000 >/proc/sys/vm/min_free_kbytes  # -- OOM issue
        # echo 10 >/proc/sys/net/core/netdev_budget # -- bad voice quality

        if [ -z "$( lsmod | grep ${mei_module})" ]; then 
            insmod `find /lib/modules -name ${mei_module}.ko` || exit 1
            echo "loaded vr9 mei driver"
        fi
        
        echo "Enter PPA mode"
        insmod `find /lib -name ifxmips_ppa_datapath_vr9_e5.ko`
        insmod `find /lib -name ifxmips_ppa_hal_vr9_e5.ko`
        insmod `find /lib -name ifx_ppa_api.ko`
        insmod `find /lib -name  ifx_ppa_api_proc.ko`
        major_ppa=`cat /proc/devices | grep "ifx_ppa" | tr -d "ifx_ppa"`
        mknod /dev/ifx_ppa c ${major_ppa} 0

        brctl delbr lan
        /sbin/ifconfig eth1 up
        /sbin/ifconfig eth0 192.168.178.1 up

        echo 1 > /proc/sys/net/ipv4/ip_forward
        echo 1 > /proc/sys/net/netfilter/nf_conntrack_tcp_be_liberal

        sleep 3
        if [ "$hook" = "dummy" ] ; then
        	echo setup dummy hooks
	        ppacmd init -d enable
        else 
	        ppacmd init 
        fi
        sleep 3

        # echo enable > /proc/ppa/api/hook         
        # sleep 1
        ppacmd control --enable-lan --enable-wan
        sleep 3

        ifconfig -a

        ppacmd addlan -i eth0

        sleep 3
        ifconfig ptm_vr9 up

        sleep 3


    ;;
    ptm)

        DSLFW="/lib/modules/dsp_vr9/vr9-B-dsl.bin"

        echo setting Annex B and J and VDSL 
        # annex B und J:

        ## ATSE_config="10_00_10_40_00_04_01_01"

        # nur annex B:
        ATSE_config="10_00_10_00_00_04_00_01"
        DSLCTL_CONFIG="-i${ATSE_config} -f${DSLFW}"
        
        echo "[load led module...]"
        modprobe ${led_module}
        rm /dev/led
        dev=$(grep led /proc/devices)
        major=${dev%%led}
        mknod /dev/led c ${major} 0
        echo "created vr9 led device node /dev/led (major: ${major}, minor: 0)"


        echo "[starting vr9 dsp...]"

        if [ -z "$( lsmod | grep ${mei_module})" ]; then 
            insmod `find /lib -name {mei_module}.ko` || exit 1
            echo "loaded vr9 mei driver"
        fi

        insmod `find /lib -name ${dsl_module}.ko` || exit 1
        echo "loaded vr9 dsl driver"

        rm -rf /dev/${dsl_device}

        dev=$(grep ${dsl_module} /proc/devices)
        major=${dev%%${dsl_module}}
        mkdir /dev/${dsl_device}
        mknod /dev/${dsl_device}/0 c ${major} 0
        echo "created vr9 dsl device node /dev/${dsl_device}/0 (major: ${major}, minor: 0)"

        #set up mei device node
        rm -f /dev/${mei_device}

        ###	... but no awk available yet
        ###	major=`awk "\\$2==\"$dsl_module\" {print \\$1}" /proc/devices`

        dev=$(grep ${mei_module} /proc/devices)
        major=${dev%%${mei_module}}
        mknod /dev/${mei_device} c ${major} 0
        echo "created vr9 mei device node /dev/${mei_device} (major: ${major}, minor: 0)"

        ${dsl_control_app} ${DSLCTL_CONFIG} &

        processes="$( ps )"
        if [ -z "$(echo ${processes} | grep ${dsl_monitor_app})" ]; then
            ${dsl_monitor_app} -d
            echo $?	
            echo "started ${dsl_monitor_app}"
        fi

        echo [....vr9 dsp started]
    ;;
    
    dsl)
        if ls -R /lib/modules/ | grep -q '^kdsldmod.ko' ; then
        ### if module in filesystem, load module and setup /dev
        modprobe kdsldmod
        ktestfile=is_this_dir_writeable
        if touch /dev/$ktestfile 2>/dev/null ; then
        rm -f /dev/$ktestfile
        devdir=/dev
        else
        devdir=/var/dev
        fi

        major=`sed -n -e 's/^ *\(.*\) avm_event$/\1/p' /proc/devices 2>/dev/null`
        if [ "$major" ] ; then
        rm -f $devdir/avm_event
        mknod $devdir/avm_event c $major 0
        chmod 666 $devdir/avm_event
        fi

        major=`sed -n -e 's/^ *\(.*\) kdsld_misc$/\1/p' /proc/devices 2>/dev/null`
        if [ "$major" ] ; then
        rm -f $devdir/kdsld_misc
        mknod $devdir/kdsld_misc c $major 0
        chmod 666 $devdir/kdsld_misc
        fi
        major=`sed -n -e 's/^ *\(.*\) kdsld_traffic$/\1/p' /proc/devices 2>/dev/null`
        if [ "$major" ] ; then
        rm -f $devdir/kdsld_traffic
        mknod $devdir/kdsld_traffic c $major 0
        chmod 666 $devdir/kdsld_traffic
        fi
        major=`sed -n -e 's/^ *\(.*\) kdsld$/\1/p' /proc/devices 2>/dev/null`
        if [ "$major" ] ; then
        rm -f $devdir/kdsld
        mknod $devdir/kdsld c $major 0
        chmod 666 $devdir/kdsld
        rm -f $devdir/kdsld_multid
        mknod $devdir/kdsld_multid c $major 1
        chmod 666 $devdir/kdsld_multid
        fi
        major=`sed -n -e 's/^ *\(.*\) kdsldptrace$/\1/p' /proc/devices 2>/dev/null`
        if [ "$major" ] ; then
        for minor in 0 1 2 3 4 17 18 19 20 ; do
        rm -f $devdir/kdsldptrace$minor
        mknod $devdir/kdsldptrace$minor c $major $minor
        chmod 666 $devdir/kdsldptrace$minor
        done
        fi
        major=`sed -n -e 's/^ *\(.*\) kdsld_user$/\1/p' /proc/devices 2>/dev/null`
        if [ "$major" ] ; then
        rm -f $devdir/kdsld_user
        mknod $devdir/kdsld_user c $major 0
        chmod 666 $devdir/kdsld_user
        fi
        fi

        echo 1 > /proc/sys/net/ipv4/ip_forward

        ### IPv6: if compiled into the kernel, set "IPv6 disabled"
        # if [ -d /proc/sys/net/ipv6/conf ] ; then
        # echo 1 > /proc/sys/net/ipv6/conf/all/forwarding
        # echo 1 > /proc/sys/net/ipv6/conf/all/disable_ipv6
        # echo 1 > /proc/sys/net/ipv6/conf/default/disable_ipv6
        # echo 0 > /proc/sys/net/ipv6/conf/default/autoconf
        # fi
        dsld -v
    ;;
    ppa_showtime)
        ppacmd addwan -i dsl
    ;;
    gdb_file)
        create_gdb_symbol_table ifx_ppa_api_proc drivers/net/ifxmips_ppa/ppa_api/ifx_ppa_api_proc.ko
        create_gdb_symbol_table ifx_ppa_api drivers/net/ifxmips_ppa/ppa_api/ifx_ppa_api.ko
        create_gdb_symbol_table ifxmips_ppa_hal_vr9_e5 drivers/net/ifxmips_ppa/platform/vr9/e5/ifxmips_ppa_hal_vr9_e5.ko
        create_gdb_symbol_table mei_vr9 drivers/mei/mei_vr9.ko
        tftp -p -l /var/add_sym.txt -r add_sym.txt 192.168.178.252
    ;;

	all)
        echo "<<<<<<<<<<<<<<<<<<<<<<< ppa_eth0 >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
        /etc/init.d/debug_ppa_init.sh ppa_eth0
        sleep 3
        
        # echo "<<<<<<<<<<<<<<<<<<<<<<< gdb_file >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
        # /etc/init.d/debug_ppa_init.sh gdb_file
        sleep 3

        echo "<<<<<<<<<<<<<<<<<<<<<<< ptm >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
        /etc/init.d/debug_ppa_init.sh ptm
        sleep 3

        echo "<<<<<<<<<<<<<<<<<<<<<<< dsl >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
        /etc/init.d/debug_ppa_init.sh dsl
        sleep 3

        # echo enable dbg > /proc/ppa/api/dbg 
        echo disable dbg > /proc/ppa/api/dbg 
        echo enable uc >  /proc/ppa/api/dbg
        echo enable hw >  /proc/ppa/api/dbg
    ;;
	dummy_dsl)
        echo "<<<<<<<<<<<<<<<<<<<<<<< setup dummy hooks >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"
        export hook=dummy
        /etc/init.d/debug_ppa_init.sh all
    ;;
    
	dummy_ata)
        echo "<<<<<<<<<<<<<<<<<<<<<<< setup dummy hooks >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>"

        export hook=dummy
        /etc/init.d/debug_ppa_init.sh ata

    ;;
	
    test_session)
    	create_test_file
    ;;
    bringup_wanlan)
	    switch_utility RegisterSet 0xCCD 0x10;
        echo "Vlan aufsetzen funktioniert im UGW 5.1 nicht mehr?!"
        return

	    LAN_PORT="0 2 3 4 5"
	    WAN_PORT="1"
	
		#Set global switch parameter
		switch_utility CfgSet 5 1 2 0 00:00:00:00:00:00
		#Create VLAN ID (LAN)
		switch_utility VLAN_IdCreate 500 1
		#Create VLAN ID (CPU)
		switch_utility VLAN_IdCreate 501 1
		#Create VLAN ID (WAN)
		switch_utility VLAN_IdCreate 502 1
		#Port VLAN configuration (LAN)
	
		for lan in $LAN_PORT; do
		    switch_utility VLAN_PortCfgSet $lan 500 0 0 3 1 1
		done
		for cpu in 6; do
		    switch_utility VLAN_PortCfgSet $cpu 501 0 0 3 1 1
		done
		for wan in $WAN_PORT; do
		    switch_utility VLAN_PortCfgSet $wan 502 0 0 3 1 1
		done
		#LAN VLAN membership
		# - 40: VLAN ID
		# - argument: Port ID
		# - 0: Tag base Number Egress disabled
		for argument in $LAN_PORT 6;do
	   		switch_utility VLAN_PortMemberAdd 500 $argument 0
		done
		#CPU VLAN membership
		# - 50: VLAN ID
		# - 0,1,2,3,6: Port ID
		# - 0: Tag base Number Egress disabled
		for argument in $LAN_PORT $WAN_PORT 6 ;do
	   		switch_utility VLAN_PortMemberAdd 501 $argument 0
		done
		#WAN VLAN membership
		# - 10: VLAN ID
		# - argument: Port ID
		# - 0: Tag base Number Egress disabled
		for argument in  $WAN_PORT 6;do
	   		switch_utility VLAN_PortMemberAdd 502 $argument 0
		done
    ;;
    
esac
